c-----------------------------------------------------
      double precision function ff(yy)
c-----------------------------------------------------
      implicit double precision(a-z)
c Integrand."yy" is 10-dimensional array
      dimension yy(10)


      integer nel
      integer ptychoice, naccur, nqqborn, nggborn,  
     # nggnlo, nqqnlo, nggnnlo, nqqnnlo
      integer  sclset         


      real*8 yy
      real*8 m2, scms
      real*8 mu2, scale, pi, alphas, b2, nlf, b3 
      real*8 alalm2, fourpi2, alpi
      real*8 ggflux, sumqqflux, sumqgflux
      real*8 delta,pt2,yyrap,yrap
      real*8 mq,muR,kR,muF          
      real*8 zeta2
      real*8 sqq0e,sqq1Re,sqq1Fe,sqq2Re,sqq2Fe,sqqRFe        
      real*8 sgg0e,sgg1Re,sgg1Fe,sgg2Re,sgg2Fe,sggRFe        
      real*8 sqq0i,sqq1Ri,sqq1Fi,sqq2Ri,sqq2Fi,sqqRFi        
      real*8 sgg0i,sgg1Ri,sgg1Fi,sgg2Ri,sgg2Fi,sggRFi        
      real*8 sqq1e,sqq2e,sgg1e,sgg2e,sqq1i,sqq2i,sgg1i,sgg2i 
      real*8 sgg21Fe,sgg21Re,sgg22Fe,sgg22Re
      real*8 sqq21Fe,sqq21Re,sqq22Fe,sqq22Re


      character*10 q
      parameter (pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)


      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2
      common/sonly/scms

      common/include/ptychoice, naccur, nqqborn, nggborn,  
     # nggnlo, nqqnlo, nggnnlo, nqqnnlo

      common/coupling/scale, alphas, nlf
      common/sclchoice/mq, muR, kR, muF, sclset 
      common/fluxes/ggflux, sumqqflux, sumqgflux
      common/plus/delta
      common/channel/nel
      common/ptyblock/pt2,yyrap




      external fq0
      external ofq10
      external ofq11
      external ofq20
      external ofq21
      external ofq22
      external SVqq
      external dSVqq
      external fg0
      external ofg20
      external ofg21
      external ofg22
      external SVgg
      external SxSgg
      external SxSgg2
      external SxSgg3del
      external SxSqq
      external SxSqq2
      external SxSqq3del

      external S21qq
      external S21qqmuR
      external S21gg
      external S21ggmuR
      external ofq11mu2
      external ofg13
      external ofg14
      external ofg15
      external ofg16
      external ofg18
      external ofq13
      external ofq14
      external ofq15
      external ofq16
      external ofq17



      mu2 = muF*muF
      

      if (ptychoice.eq.0) then

         mtr2 = m2 + pt2

         jcbmtr2 = 2d0*dsqrt(pt2)
         sovmt2  = scms/mtr2

         yrapmin = -dlog(dsqrt(sovmt2)/2.+dsqrt(sovmt2/4.-1d0))
         yrapmax = dlog(dsqrt(sovmt2)/2.+dsqrt(sovmt2/4.-1d0))
         yrap    = yrapmin + (yrapmax-yrapmin)*
     ~        dlog(1d0+yy(2)*(exp(1d0)-1d0))
         jcbyrap = (yrapmax-yrapmin)*(exp(1d0)-1d0)/
     ~        (1d0+yy(2)*(exp(1d0)-1d0))

 
      elseif (ptychoice.eq.1) then

         yrap    = yyrap
         jcbyrap = 1d0

         mtr2min = m2
         mtr2max = scms/(exp(yrap)+exp(-yrap))**2
         mtr2    = mtr2min + (mtr2max-mtr2min)*yy(2)
         jcbmtr2 = mtr2max-mtr2min

      elseif (ptychoice.eq.2) then

         mtr2min = m2
         mtr2max = scms/4.
         mtr2    = mtr2min + (mtr2max-mtr2min)*yy(1)
         jcbmtr2 = mtr2max-mtr2min
         sovmt2  = scms/mtr2

         yrapmin = -dlog(dsqrt(sovmt2)/2.+dsqrt(sovmt2/4.-1d0))
         yrapmax = dlog(dsqrt(sovmt2)/2.+dsqrt(sovmt2/4.-1d0))

         yrap    = yrapmin + (yrapmax-yrapmin)*
     ~        dlog(1d0+yy(2)*(exp(1d0)-1d0))
         jcbyrap = (yrapmax-yrapmin)*(exp(1d0)-1d0)/
     ~        (1d0+yy(2)*(exp(1d0)-1d0))

      elseif (ptychoice.eq.3) then

         betacap = dsqrt(1d0-4d0*m2/scms)
         yrapmin = -dlog((1d0+betacap)/(1d0-betacap))/2.
         yrapmax = dlog((1d0+betacap)/(1d0-betacap))/2.

         yrap    = yrapmin + (yrapmax-yrapmin)*
     ~        dlog(1d0+yy(1)*(exp(1d0)-1d0))
         jcbyrap = (yrapmax-yrapmin)*(exp(1d0)-1d0)/
     ~        (1d0+yy(1)*(exp(1d0)-1d0))

         mtr2min = m2
         mtr2max = scms/(exp(yrap)+exp(-yrap))**2
         mtr2    = mtr2min + (mtr2max-mtr2min)*yy(2)
         jcbmtr2 = mtr2max-mtr2min

      else 
         print*,'wrong choice of distribution: check ptychoice'
         stop
      endif

      t1cap = -dsqrt(scms*mtr2)*exp(yrap)
      u1cap = -dsqrt(scms*mtr2)*exp(-yrap)

      z1min = -u1cap/(scms+t1cap)
      z1max = 1d0
      z1 = z1min + (z1max-z1min)*yy(3) 
      jcbz1 = z1max-z1min


      if (nel.eq.1) then
        
        s4imin = delta
        s4imax = z1*(scms+t1cap)+u1cap
        
        sratio = s4imax/s4imin
        s4i    = s4imin*sratio**yy(4)
        jcbs4i = s4i*dlog(sratio)   
        
        z2i   = (s4i-z1*t1cap)/(z1*scms+u1cap)
        si = z1*z2i*scms
        t1 = z1*t1cap
        u1i= s4i-si-t1
        
        
        
        jacobi = jcbz1*jcbs4i/(z1*scms+u1cap)*
     ~    scms*z1*z2i*jcbyrap*jcbmtr2
        
        if(z1 .lt. 1.d0 .and. z2i .lt. 1.d0) then
          call hadfold(z1,z2i)
        else
          ff = 0.d0 
          return 
        endif
        
      elseif (nel.eq. 0 .or. nel .eq. 2) then
        
        z2e   = -z1*t1cap/(z1*scms+u1cap)
        se = z1*z2e*scms
        t1 = z1*t1cap
        u1e= -se-t1
        
        
        jacobe = jcbz1/(z1*scms+u1cap)*
     ~    scms*z1*z2e*jcbyrap*jcbmtr2
        
        if(z1 .lt. 1.d0 .and. z2e .lt. 1.d0) then
          call hadfold(z1,z2e)
        else
          ff = 0.d0 
          return 
        endif
        
      endif

      b2 = (11d0*CA-2d0*nf)/12d0
      b3 = (34d0*CA**2-2d0*nf*(3d0*CF+5d0*CA))/48d0
      alalm2   = alphas**2/m2
      alpi     = alphas/pi
      fourpi2  = 4.d0*pi**2

      ff = 0.d0

c*****************************************************
c Born terms 
c*****************************************************
      if (nel.eq.0) then
        if (nggborn .eq. 1) then
          sgg0e=fg0(se,t1,u1e)
        ff = ff + alalm2 *sgg0e* ggflux*jacobe
        endif
        if (nqqborn .eq. 1) then
          sqq0e=fq0(se,t1,u1e)
          ff = ff + alalm2* sqq0e *sumqqflux*jacobe
        endif
      endif
!======================================================

c*****************************************************
c elastic part
c*****************************************************
      if (nel.eq.2) then
c
c NNLL accurracy 
c
      if (nggnlo .eq. 1 .and. naccur .eq. 2) then

!constant term
        sgg1e = dlog(delta/m2)**2/2.*4d0*CA*fg0(se,t1,u1e)
     ~    + dlog(delta/m2)*ofg10(se,t1,u1e)
     ~    + fourpi2*(SVgg(se,t1,u1e)+SVgg(se,u1e,t1)) 

!single-logmuF logmuR terms
        sgg1Fe=(-dlog(delta/m2)*2d0*CA+ofg11(se,t1,u1e))*fg0(se,t1,u1e)
        sgg1Re=2d0*b2*fg0(se,t1,u1e)

         ff = ff + alpi* alalm2* ggflux*(
     ~     sgg1e 
     ~    +dlog(muF**2/m2)*sgg1Fe
     ~    +dlog(muR**2/m2)*sgg1Re                 
     ~    -dlog(muF**2/m2)*sgg1Re                 
     ~   )*jacobe 
      endif
!========================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 2) then
!constant term
        sgg2e = dlog(delta/m2)**4/4.*8d0*CA**2*fg0(se,t1,u1e)
     ~    +dlog(delta/m2)**3/3.*ofg20(se,t1,u1e)
     ~    +dlog(delta/m2)**2/2.*fourpi2**2*(CA/pi**2*
     ~           (SVgg(se,t1,u1e)+SVgg(se,u1e,t1))+SxSgg(se,t1,u1e))
     ~    +dlog(delta/m2)*                                   
     ~       (fourpi2*(SVgg(se,t1,u1e)+SVgg(se,u1e,t1))*ofg16(se,t1,u1e)  
     ~          +SxSgg2(se,t1,u1e))                          
     ~    +SxSgg3del(se,t1,u1e)                                         

!Log(muF**2/m2) term
        sgg21Fe = (-dlog(delta/m2)**3/3.*12d0*CA**2*fg0(se,t1,u1e)
     ~    +dlog(delta/m2)**2/2.*ofg21(se,t1,u1e) 
     ~    +dlog(delta/m2)*fourpi2**2*( S21gg(se,t1,u1e)-
     ~    CA/2./pi**2*(SVgg(se,t1,u1e)+SVgg(se,u1e,t1))))
     ~    +(fourpi2*(SVgg(se,t1,u1e)+SVgg(se,u1e,t1))*ofg13(se,t1,u1e)
     ~       +ofg14(se,t1,u1e)*fg0(se,t1,u1e) + ofg15(se,t1,u1e))

!Log(muR**2/m2) term
        sgg21Re =dlog(delta/m2)*fourpi2**2*S21ggmuR(se,t1,u1e)
     ~           +dlog(delta/m2)**2/2d0*(12d0*CA*b2)*fg0(se,t1,u1e)
     ~    +(ofg18(se,t1,u1e)*fg0(se,t1,u1e)
     ~           +3d0/16d0*b2*fourpi2*(SVgg(se,t1,u1e)+SVgg(se,u1e,t1)))

!Log(muF**2/m2)**2 term
        sgg22Fe = (dlog(delta/m2)**2/2.*4d0*CA**2 !v
     ~      +dlog(delta/m2)*ofg22(se,t1,u1e) -(CA*pi)**2/3.
     ~	      +ofg11(se,t1,u1e)*(-5d0*b2+ofg11(se,t1,u1e))/2.)*
     ~ 		fg0(se,t1,u1e)                                 

!Log(muR**2/m2)**2 term
        sgg22Re = 3d0*b2**2*fg0(se,t1,u1e)

!Log(muR**2/m2)*Log(muF**2/m2) term
        sggRFe = dlog(delta/m2)*(-6d0*b2*CA)*fg0(se,t1,u1e)
     ~    +3d0*b2*ofg11(se,t1,u1e)*fg0(se,t1,u1e)

         ff = ff + alpi**2* alalm2* ggflux*( 
     ~    sgg2e
     ~    +dlog(muF**2/m2) *sgg21Fe
     ~    +dlog(muR**2/m2) *sgg21Re  
     ~    +dlog(muF**2/m2)**2*sgg22Fe
     ~    +dlog(muF**2/m2)*dlog(muR**2/m2)*sggRFe              
     ~    +dlog(muR**2/m2)**2*sgg22Re                         
     ~    +dlog(muR**2/m2)*dlog(muF**2/m2)*(-2.)*sgg22Re          
     ~    +dlog(muF**2/m2)**2*sgg22Re                         
     ~    )* jacobe
      endif
!==============================================================

      if (nqqnlo .eq. 1 .and. naccur .eq. 2) then

!const term
        sqq1e = (dlog(delta/m2)**2/2.*4d0*CF
     ~      +dlog(delta/m2)*ofq10(se,t1,u1e))*fq0(se,t1,u1e)
     ~      + fourpi2*SVqq(se,t1,u1e)

!Log(muF**2/m2) term
        sqq1Fe=(-dlog(delta/m2)*2d0*CF+ofq11(se,t1,u1e))*fq0(se,t1,u1e) 

!Log(muR**2/m2) term
        sqq1Re = 2d0*b2*fq0(se,t1,u1e)

         ff = ff + alpi* alalm2* sumqqflux*(
     ~    sqq1e
     ~    +dlog(muF**2/m2)*sqq1Fe
     ~    +dlog(muR**2/m2)*sqq1Re                      
     ~     )* jacobe 
      endif
!================================

      if (nqqnnlo .eq. 1  .and. naccur .eq. 2) then
!const. term
        sqq2e = (dlog(delta/m2)**4/4.*8d0*CF**2
     ~      +dlog(delta/m2)**3/3.*ofq20(se,t1,u1e))*fq0(se,t1,u1e)
     ~	    +dlog(delta/m2)**2/2.*fourpi2**2*(
     ~           CF/pi**2*SVqq(se,t1,u1e)+SxSqq(se,t1,u1e))
     ~      +dlog(delta/m2)*                                
     ~      (fourpi2*SVqq(se,t1,u1e)*ofq15(se,t1,u1e)
     ~    +SxSqq2(se,t1,u1e) )                        
     ~      +fourpi2*SVqq(se,t1,u1e)*ofq16(se,t1,u1e) 
     ~        + SxSqq3del(se,t1,u1e)                

!Log(muF**2/m2) term
        sqq21Fe = 
     ~	    (-dlog(delta/m2)**3/3.*12d0*CF**2
     ~    +dlog(delta/m2)**2/2.*ofq21(se,t1,u1e))*fq0(se,t1,u1e)
     ~    +dlog(delta/m2)*fourpi2**2*(S21qq(se,t1,u1e)
     ~    -CF/2./pi**2*SVqq(se,t1,u1e))
     ~    + (ofq13(se,t1,u1e)*fq0(se,t1,u1e)
     ~    + fourpi2*SVqq(se,t1,u1e)*ofq14(se,t1,u1e))

!Log(muR**2/m2) term
        sqq21Re = (dlog(delta/m2)**2/2.*12d0*b2*CF)*fq0(se,t1,u1e)
     ~    +  dlog(delta/m2)*fourpi2**2*S21qqmuR(se,t1,u1e)
     ~    + (ofq17(se,t1,u1e)*fq0(se,t1,u1e)
     ~    +3./16.*b2*fourpi2*SVqq(se,t1,u1e))

!Log(muF**2/m2)**2 term
        sqq22Fe =( dlog(delta/m2)**2/2.*4d0*CF**2
     ~    +dlog(delta/m2)*ofq22(se,t1,u1e)
     ~    +ofq11mu2(se,t1,u1e))*fq0(se,t1,u1e)                    

!Log(muR**2/m2)**2 term
        sqq22Re =(3d0*b2**2)*fq0(se,t1,u1e)

!Log(muR**2/m2)*Log(muF**2/m2) term
        sqqRFe =dlog(delta/m2)*(-6d0*b2*CF)*fq0(se,t1,u1e) 
     ~    +3d0*b2*ofq11(se,t1,u1e)*fq0(se,t1,u1e)

         ff = ff + alpi**2* alalm2* sumqqflux*( 
     ~    sqq2e
     ~    +dlog(muF**2/m2)*sqq21Fe
     ~    +dlog(muR**2/m2)*sqq21Re                                 
     ~    +dlog(muF**2/m2)**2*sqq22Fe
     ~    +dlog(muR**2/m2)**2*sqq22Re                                         
     ~    +dlog(muF**2/m2)*dlog(muR**2/m2)*sqqRFe                              
     ~)* jacobe
      endif
!==========================================================================


c
c NLL accurracy 
c
      if (nggnlo .eq. 1 .and. naccur .eq. 1) then

!const term
        sgg1e = dlog(delta/m2)**2/2.*4d0*CA*fg0(se,t1,u1e)
     ~    +dlog(delta/m2)*ofg10(se,t1,u1e)

!Log(muF**2/m2) term        
        sgg1Fe = (-dlog(delta/m2)*2d0*CA+ofg11(se,t1,u1e))
     ~    *fg0(se,t1,u1e)

!Log(muR**2/m2) term        
        sgg1Re = 2d0*b2*fg0(se,t1,u1e)

         ff = ff + alpi* alalm2* ggflux*( 
     ~    sgg1e
     ~    +dlog(muF**2/m2)*sgg1Fe              
     ~    +dlog(muR**2/m2)*sgg1Re      
     ~    -dlog(muF**2/m2)*sgg1Re      
     ~     )* jacobe 
      endif
!=========================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 1) then
!const term
        sgg2e = 
     ~	    dlog(delta/m2)**4/4.*8d0*CA**2*fg0(se,t1,u1e)
     ~     +dlog(delta/m2)**3/3.*ofg20(se,t1,u1e)

!Log(muF**2/m2) term
        sgg21Fe=
     ~	   (-dlog(delta/m2)**3/3.*12d0*CA**2*fg0(se,t1,u1e)
     ~      +dlog(delta/m2)**2/2.*ofg21(se,t1,u1e)) 

!Log(muR**2/m2) term
        sgg21Re= (12d0*b2*CA*dlog(delta/m2)**2/2.)*fg0(se,t1,u1e)

!Log(muF**2/m2)**2 term
        sgg22Fe = (dlog(delta/m2)**2/2.*4d0*CA**2
     ~    +dlog(delta/m2)*ofg22(se,t1,u1e))*fg0(se,t1,u1e)

!Log(muF**2/m2)*Log(muR**2/m2) term
        sggRFe = dlog(delta/m2)*(-6d0*b2*CA)*fg0(se,t1,u1e)   

         ff = ff + alpi**2* alalm2* ggflux*( 
     ~    sgg2e
     ~    +dlog(muF**2/m2)*sgg21Fe
     ~    +dlog(muR**2/m2)*sgg21Re                            
     ~    +dlog(muF**2/m2)**2*sgg22Fe
     ~    +dlog(muF**2/m2)*dlog(muR**2/m2)*sggRFe                  
     ~     )* jacobe 
      endif
!============================================================

      if (nqqnlo .eq. 1  .and. naccur .eq. 1) then

!const term
        sqq1e=(dlog(delta/m2)**2/2.*4d0*CF
     ~    +dlog(delta/m2)*ofq10(se,t1,u1e))*fq0(se,t1,u1e)

!Log(muF**2/m2)term        
        sqq1Fe = (-dlog(delta/m2)*2.d0*CF
     ~    +ofq11(se,t1,u1e))*fq0(se,t1,u1e)

!Log(muR**2/m2) term        
        sqq1Re =  2d0*b2*fq0(se,t1,u1e)

         ff = ff + alpi* alalm2* sumqqflux*(
     ~    sqq1e
     ~    +dlog(muF**2/m2)*sqq1Fe
     ~	  +dlog(muR**2/m2)*sqq1Re                   
     ~    )* jacobe 
cmarco added dlog(muR**2/m2)
      endif
!=============================================================

      if (nqqnnlo .eq. 1 .and. naccur .eq. 1) then

!const term
        sqq2e=(dlog(delta/m2)**4/4.*8d0*CF**2
     ~    +dlog(delta/m2)**3/3.*ofq20(se,t1,u1e))*fq0(se,t1,u1e)

!Log(muF**2/m2) term        
        sqq21Fe = (-dlog(delta/m2)**3/3.*12d0*CF**2
     ~      +dlog(delta/m2)**2/2.*ofq21(se,t1,u1e))*fq0(se,t1,u1e)

!Log(muR**2/m2) term        
        sqq21Re = (dlog(delta/m2)**2/2.*12d0*CF*b2)*fq0(se,t1,u1e) 

!Log(muF**2/m2)**2 term  
        sqq22Fe = (dlog(delta/m2)**2/2.*4d0*CF**2
     ~    +dlog(delta/m2)*ofq22(se,t1,u1e))*fq0(se,t1,u1e)

!Log(muF**2/m2)*Log(muR**2/m2) term
       sqqRFe = dlog(delta/m2)*(-6d0*CF*b2)*fq0(se,t1,u1e)            

        ff = ff + alpi**2* alalm2* sumqqflux*( 
     ~    sqq2e
     ~    +dlog(mu2/m2)*sqq21Fe
     ~    +dlog(muR**2/m2)*sqq21Re
     ~    +dlog(muF**2/m2)**2*sqq22Fe
     ~    +dlog(muF**2/m2)*dlog(muR**2/m2)*sqqRFe
     ~ )* jacobe 
      endif
!==========================================================================

c
c LL accurracy 
c
      if (nggnlo .eq. 1 .and. naccur .eq. 0) then

!const term
        sgg1e=dlog(delta/m2)**2/2.*4d0*CA*fg0(se,t1,u1e)
        
!Log(muF**2/m2) term
        sgg1Fe= (-dlog(delta/m2)*2d0*CA)*fg0(se,t1,u1e)
        
        ff = ff + alpi* alalm2* ggflux*( 
     ~    sgg1e   
     ~    +dlog(mu2/m2)*sgg1Fe
     ~    )* jacobe
      endif
!============================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 0) then
!const term
        sgg2e=dlog(delta/m2)**4/4.*8d0*CA**2*fg0(se,t1,u1e)

!Log(muF**2/m2) term
        sgg21Fe=(-dlog(delta/m2)**3/3.*12d0*CA**2)*fg0(se,t1,u1e)

!Log(muF**2/m2)**2 term        
        sgg22Fe= (dlog(delta/m2)**2/2.*4d0*CA**2)*fg0(se,t1,u1e)

         ff = ff + alpi**2* alalm2* ggflux*(
     ~    sgg2e
     ~    +dlog(muF**2/m2)*sgg21Fe
     ~    +dlog(muF**2/m2)**2*sgg22Fe
     ~      )*jacobe  
      endif
!============================================================

      if (nqqnlo .eq. 1 .and. naccur .eq. 0) then
!const term
        sqq1e = (dlog(delta/m2)**2/2.*4d0*CF)*fq0(se,t1,u1e)
!Log(muF**2/m2) term
        sqq1Fe= (-dlog(delta/m2)*2d0*CF)*fq0(se,t1,u1e)
!Log(muF**2/m2)**2 term        

         ff = ff + alpi* alalm2* sumqqflux*(
     ~    sqq1e
     ~    +dlog(muF**2/m2)*sqq1Fe
     ~  )* jacobe
      endif
!============================================================


      if (nqqnnlo .eq. 1  .and. naccur .eq. 0) then
!const term
        sqq2e= (dlog(delta/m2)**4/4.*8d0*CF**2)*fq0(se,t1,u1e)

!Log(muF**2/m2) term
        sqq21Fe=(-dlog(delta/m2)**3/3.*12d0*CF**2)*fq0(se,t1,u1e)

!Log(muF**2/m2)**2 term
        sqq22Fe= (dlog(delta/m2)**2/2.*4d0*CF**2)*fq0(se,t1,u1e)

         ff = ff + alpi**2* alalm2* sumqqflux*(
     ~	   sqq2e
     ~    +dlog(muF**2/m2)*sqq21Fe
     ~    +dlog(muF**2/m2)**2*sqq22Fe
     ~      )*jacobe
      endif
!========================================================================

      endif




c*******************************************************
* inelastic part 
c*******************************************************
      if (nel.eq.1) then
c
c NNLL accurracy
c
      if (nggnlo .eq. 1 .and. naccur .eq. 2) then

!const term
        sgg1i=dlog(s4i/m2)/s4i*4d0*CA*fg0(si,t1,u1i)
     ~    +1d0/s4i*ofg10(si,t1,u1i)

!Log(muF**2/m2) term
        sgg1Fi=(-1d0/s4i*2d0*CA*fg0(si,t1,u1i))

         ff = ff + alpi* alalm2* ggflux*( 
     ~    sgg1i
     ~    +dlog(muF**2/m2)*sgg1Fi
     ~     )* jacobi
      endif
!========================================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 2) then

!const term
        sgg2i = 
     ~    dlog(s4i/m2)**3/s4i*8d0*CA**2*fg0(si,t1,u1i)
     ~    +dlog(s4i/m2)**2/s4i*ofg20(si,t1,u1i)
     ~    +dlog(s4i/m2)/s4i*fourpi2**2*(CA/pi**2*
     ~    (SVgg(si,t1,u1i)+SVgg(si,u1i,t1))+SxSgg(si,t1,u1i))
     ~    +1d0/s4i*             
     ~    (fourpi2*(SVgg(si,t1,u1i)+SVgg(si,u1i,t1))
     ~    *ofg16(si,t1,u1i)+SxSgg2(si,t1,u1i))  
        
!Log(muF**2/m2) term
        sgg21Fi=
     ~    (-dlog(s4i/m2)**2/s4i*12d0*CA**2*fg0(si,t1,u1i) !v
     ~    +dlog(s4i/m2)/s4i*ofg21(si,t1,u1i) !v
     ~	  +1d0/s4i*fourpi2**2*(S21gg(si,t1,u1i)- 
     ~    CA/2./pi**2*(SVgg(si,t1,u1i)+SVgg(si,u1i,t1))))

!Log(muR**2/m2) term
        sgg21Ri=dlog(s4i/m2)/s4i*12d0*CA*b2*fg0(si,t1,u1i) !v
     ~    +1d0/s4i*fourpi2**2*S21ggmuR(si,t1,u1i)

!Log(muR**2/m2)*Log(muF**2/m2) term
        sggRFi=1d0/s4i*(-6d0*b2*CA)*fg0(si,t1,u1i)

!Log(muF**2/m2)**2 term
        sgg22Fi=(dlog(s4i/m2)/s4i*4d0*CA**2
     ~      +1d0/s4i*ofg22(si,t1,u1i))*fg0(si,t1,u1i) 

         ff = ff + alpi**2* alalm2* ggflux*( 
     ~    sgg2i
     ~    +dlog(muF**2/m2)*sgg21Fi
     ~    +dlog(muR**2/m2)*sgg21Ri              
     ~    +dlog(muR**2/m2)*dlog(muF**2/m2)*sggRFi
     ~    +dlog(mu2/m2)**2*sgg22Fi
     ~    )* jacobi
      endif
!========================================================================

      if (nqqnlo .eq. 1  .and. naccur .eq. 2) then

!const term
        sqq1i=(dlog(s4i/m2)/s4i*4d0*CF
     ~    +1d0/s4i*ofq10(si,t1,u1i))*fq0(si,t1,u1i)

!Log(muF**2/m2) term
        sqq1Fi=(-1d0/s4i*2d0*CF*fq0(si,t1,u1i))

         ff = ff + alpi* alalm2* sumqqflux*( 
     ~    sqq1i
     ~    +dlog(muF**2/m2)*sqq1Fi
     ~    )* jacobi
      endif
!========================================================================

      if (nqqnnlo .eq. 1  .and. naccur .eq. 2) then
!const term
        sqq2i=
     ~      (dlog(s4i/m2)**3/s4i*8d0*CF**2
     ~      +dlog(s4i/m2)**2/s4i*ofq20(si,t1,u1i))*fq0(si,t1,u1i)
     ~	    +dlog(s4i/m2)/s4i*fourpi2**2*(
     ~           CF/pi**2*SVqq(si,t1,u1i) + SxSqq(si,t1,u1i))
     ~      +1d0/s4i*                     
     ~         (fourpi2*SVqq(si,t1,u1i)*ofq15(si,t1,u1i)
     ~          +SxSqq2(si,t1,u1i)) 

!Log(muF**2/m2) term
        sqq21Fi=
     ~	    ((-dlog(s4i/m2)**2/s4i*12d0*CF**2
     ~      +dlog(s4i/m2)/s4i*ofq21(si,t1,u1i))*fq0(si,t1,u1i)
     ~      +1d0/s4i*fourpi2**2*(S21qq(si,t1,u1i)
     ~	      -CF/2./pi**2*SVqq(si,t1,u1i)))

!Log(muR**2/m2) term
        sqq21Ri=(12d0*b2*CF*dlog(s4i/m2)/s4i)*fq0(si,t1,u1i)
     ~    + 1d0/s4i*fourpi2**2*S21qqmuR(si,t1,u1i)

!Log(muF**2/m2)**2 term
        sqq22Fi=(dlog(s4i/m2)/s4i*4d0*CF**2
     ~    +1d0/s4i*ofq22(si,t1,u1i))*fq0(si,t1,u1i) 

!Log(muF**2/m2)*Log(muR**2/m2) term
        sqqRFi=1d0/s4i*(-6d0*CF*b2)*fq0(si,t1,u1i) 

         ff = ff + alpi**2* alalm2* sumqqflux*( 
     ~    sqq2i
     ~    +dlog(muF**2/m2)*sqq21Fi
     ~    +dlog(muR**2/m2)*sqq21Ri              
     ~    +dlog(mu2/m2)**2*sqq22Fi
     ~    +dlog(muR**2/m2)*dlog(muF**2/m2)*sqqRFi
     ~ ) * jacobi
      endif
!========================================================================


c
c NLL accurracy
c
      if (nggnlo .eq. 1 .and. naccur .eq. 1) then
!const term
        sgg1i=dlog(s4i/m2)/s4i*4d0*CA*fg0(si,t1,u1i)
     ~    +1d0/s4i*ofg10(si,t1,u1i)

!Log(muF**2/m2) term
        sgg1Fi=(-1d0/s4i*2d0*CA*fg0(si,t1,u1i))

         ff = ff + alpi* alalm2* ggflux*( 
     ~    sgg1i
     ~    +dlog(mu2/m2)*sgg1Fi
     ~    )* jacobi 
      endif
!=============================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 1) then

!const term
        sgg2i = dlog(s4i/m2)**3/s4i*8d0*CA**2*fg0(si,t1,u1i)
     ~    +dlog(s4i/m2)**2/s4i*ofg20(si,t1,u1i)

!Log(muF**2/m2) term
        sgg21Fi=(-dlog(s4i/m2)**2/s4i*12d0*CA**2
     ~    *fg0(si,t1,u1i)+dlog(s4i/m2)/s4i*ofg21(si,t1,u1i)) 

!Log(muR**2/m2) term
        sgg21Ri=(dlog(s4i/m2)/s4i*12d0*b2*CA)*fg0(si,t1,u1i)

!Log(muF**2/m2)**2 term
        sgg22Fi=(dlog(s4i/m2)/s4i*4d0*CA**2
     ~    +1d0/s4i*ofg22(si,t1,u1i))*fg0(si,t1,u1i) 
!Log(muF**2/m2)*Log(muR**2/m2) term
        sggRFi=1d0/s4i*(-6d0*b2*CA*fg0(si,t1,u1i)) 

         ff = ff + alpi**2* alalm2* ggflux*( 
     ~    sgg2i
     ~    +dlog(muF**2/m2)*sgg21Fi
     ~    +dlog(muR**2/m2)*sgg21Ri          
     ~    +dlog(muF**2/m2)**2*sgg22Fi
     ~    +dlog(mu2/m2)*dlog(muR**2/m2)*sggRFi 
     ~    )* jacobi
       endif
!=============================================================
      if (nqqnlo .eq. 1  .and. naccur .eq. 1) then
!const term
        sqq1i=(dlog(s4i/m2)/s4i*4d0*CF
     ~      +1d0/s4i*ofq10(si,t1,u1i))*fq0(si,t1,u1i)

!Log(muF**2/m2) term
        sqq1Fi=(-1d0/s4i*2d0*CF*fq0(si,t1,u1i))

         ff = ff + alpi* alalm2* sumqqflux*(
     ~    sqq1i
     ~    +dlog(mu2/m2)*sqq1Fi
     ~   )* jacobi
      endif
!=============================================================


      if (nqqnnlo .eq. 1  .and. naccur .eq. 1) then
!const term

        sqq2i=
     ~      (dlog(s4i/m2)**3/s4i*8d0*CF**2
     ~      +dlog(s4i/m2)**2/s4i*ofq20(si,t1,u1i))*fq0(si,t1,u1i)

!Log(muF**2/m2) term
        sqq21Fi=
     ~	    (-dlog(s4i/m2)**2/s4i*12d0*CF**2
     ~      +dlog(s4i/m2)/s4i*ofq21(si,t1,u1i))*fq0(si,t1,u1i)

!Log(muR**2/m2) term
        sqq21Ri=(dlog(s4i/m2)/s4i*12d0*CF*b2)*fq0(si,t1,u1i)

!Log(muF**2/m2)**2 term
        sqq22Fi=
     ~    (dlog(s4i/m2)/s4i*4d0*CF**2
     ~      +1d0/s4i*ofq22(si,t1,u1i))*fq0(si,t1,u1i) 

!Log(muR**2/m2)*Log(muF**2/m2) term
        sqqRFi=1/s4i*(-6d0*CF*b2)*fq0(si,t1,u1i)

        ff = ff + alpi**2* alalm2* sumqqflux*( 
     ~    sqq2i
     ~    +dlog(mu2/m2)*sqq21Fi
     ~    +dlog(muR**2/m2)*sqq21Ri
     ~    +dlog(muF**2/m2)**2*sqq22Fi
     ~    +dlog(muF**2/m2)*dlog(muR**2/m2)*sqqRFi
     ~    )* jacobi
      endif
!=====================================================================


c
c LL accurracy
c
      if (nggnlo .eq. 1 .and. naccur .eq. 0) then

!const term
        sgg1i=dlog(s4i/m2)/s4i*4d0*CA*fg0(si,t1,u1i)

!Log(muF**2/m2) term
        sgg1Fi=(-1d0/s4i*2d0*CA*fg0(si,t1,u1i))

         ff = ff + alpi* alalm2* ggflux*( 
     ~    sgg1i
     ~    +dlog(muF**2/m2)*sgg1Fi
     ~    )* jacobi
       endif
!=======================================================

      if (nggnnlo .eq. 1 .and. naccur .eq. 0) then

!const term
      sgg2i= dlog(s4i/m2)**3/s4i*8d0*CA**2*fg0(si,t1,u1i)

!Log(muF**2/m2) term
      sgg21Fi= (-dlog(s4i/m2)**2/s4i*12d0*CA**2)*fg0(si,t1,u1i)

!Log(muF**2/m2)**2 term
      sgg22Fi=(dlog(s4i/m2)/s4i*4d0*CA**2)*fg0(si,t1,u1i)

      ff = ff + alpi**2* alalm2* ggflux*( 
     ~  sgg2i  
     ~  +dlog(muF**2/m2)* sgg21Fi
     ~  +dlog(muF**2/m2)**2*sgg22Fi
     ~  )*jacobi
      endif
!=======================================================
      if (nqqnlo .eq. 1  .and. naccur .eq. 0) then
!const term
        sqq1i=(dlog(s4i/m2)/s4i*4d0*CF)*fq0(si,t1,u1i)

!Log(muF**2/m2) term
        sqq1Fi=(-1d0/s4i*2d0*CF*fq0(si,t1,u1i)) 

         ff = ff + alpi* alalm2* sumqqflux*(
     ~    sqq1i 
     ~    +dlog(mu2/m2)* sqq1Fi
     ~    )* jacobi
      endif
!=====================================================


      if (nqqnnlo .eq. 1  .and. naccur .eq. 0) then

!const term
        sqq2i=(dlog(s4i/m2)**3/s4i*8d0*CF**2)*fq0(si,t1,u1i)

!Log(muF**2/m2) term
        sqq21Fi=(-dlog(s4i/m2)**2/s4i*12d0*CF**2)*fq0(si,t1,u1i)

!Log(muF**2/m2)**2 term
        sqq22Fi=(dlog(s4i/m2)/s4i*4d0*CF**2)*fq0(si,t1,u1i)

         ff = ff + alpi**2* alalm2* sumqqflux*( 
     ~    sqq2i
     ~    +dlog(muF**2/m2)*sqq21Fi
     ~    +dlog(muF**2/m2)**2* sqq22Fi
     ~   )* jacobi
      endif
!==============================================================

      endif
  
c conversion to express the cross section in pico barn
      ff = 19733.d0*19733.d0*ff


      return
      end

*----------------------------------
c Born functions
*----------------------------------
      double precision function fq0(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi
      parameter( pi = 3.14159265359d0 )
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      integer nel
      common/channel/nel

      fq0 = m2/s**2*pi*CF/CA*
     +     ((t1**2+u1**2)/s**2+2d0*m2/s)


      Return
      End
*----------------------------------
      double precision function fg0(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,BQED
      parameter( pi = 3.14159265359d0 )
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      integer nel
      common/channel/nel

      BQED = t1/u1+u1/t1+4d0*m2*s/t1/u1*(1d0-m2*s/t1/u1)
      fg0 = m2/s**2*pi/2./(CA**2-1d0)**2
     +     *BQED*(CO*(1d0-2d0*t1*u1/s**2)-CK)

      
      Return
      End
*----------------------------------
* 1PI kinmatics
*----------------------------------
      double precision function ofq10(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,beta,Lbeta
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     

      ofq10 = - CA*lnsm + 4*CA*lntm - 2*CA*lnum + CA*Lbeta 
     +     + 2*CF*lnsm - 10*CF*lntm + 6*CF*lnum - 2*CF*Lbeta - 2*CF


      Return
      End
*----------------------------------
      double precision function ofq11mu2(s,t1,u1)
      IMPLICIT none
      integer  sclset         
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2, zeta2 
      real*8 mq,muR,kR,muF                      
      parameter (zeta2 = 1.64493d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2
      common/sclchoice/mq, muR, kR, muF, sclset 

      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      
      ofq11mu2 = (3d0*b2*CF)/4d0 + (9d0*CF**2)/8d0 - (b2*CF*lntm)/2d0 
     ~  - (3d0*CF**2*lntm)/2d0 + (CF**2*lntm**2)/2d0 
     ~  - (b2*CF*lnum)/2d0 - (3d0*CF**2*lnum)/2d0 
     ~  + CF**2*lntm*lnum + (CF**2*lnum**2)/2d0 - 2d0*CF**2*zeta2
      
      Return
      End
*----------------------------------
      double precision function ofq11(s,t1,u1)
      IMPLICIT none
      integer  sclset         
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2 
      real*8 mq,muR,kR,muF                      
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2
      common/sclchoice/mq, muR, kR, muF, sclset 

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)

      ofq11 = CF*lntm + CF*lnum - 3./2.*CF 


      Return
      End
*----------------------------------
      double precision function ofq11d(s,t1,u1)
      IMPLICIT none
      integer  sclset         
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 zeta2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2 
      real*8 mq,muR,kR,muF                      
      parameter (zeta2 = 1.64493d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2
      common/sclchoice/mq, muR, kR, muF, sclset 
      
      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      
      ofq11d = -CF/2d0*(lntm+lnum)**2 
     +         -CF*3d0/4d0*(lntm+lnum) + CF*lntm*lnum 
     +        + 9d0/2d0 +2d0*zeta2

      Return
      End
*----------------------------------
      double precision function ofq20(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,beta,Lbeta,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     

      ofq20 = - 6*CA*CF*lnsm + 24*CA*CF*lntm - 12*CA*CF*lnum 
     +     + 6*CA*CF*Lbeta - 4*CF*b2 + 12*CF**2*lnsm - 60*CF**2*lntm 
     +     + 36*CF**2*lnum - 12*CF**2*Lbeta - 12*CF**2

      Return
      End
*----------------------------------
      double precision function ofq21(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1,b2
      real*8 lntm,lnum,lnsm,beta,Lbeta
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2 
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     


      ofq21 = 4*CA*CF*lnsm - 16*CA*CF*lntm + 8*CA*CF*lnum 
     +     - 4*CA*CF*Lbeta 
     +     - 8*CF**2*lnsm + 44*CF**2*lntm 
     +     - 20*CF**2*lnum + 8*CF**2*Lbeta + 2*CF**2


      Return
      End
*----------------------------------
      double precision function ofq22(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 dump1, dump2
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)


      ofq22 = CF*b2 - 2*CF**2*lntm - 2*CF**2*lnum + 3*CF**2 

      Return
      End

*----------------------------------
      double precision function ofq13(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2,g2qq
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira,Lbeta,beta
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      beta = dsqrt(1d0-4*m2/s)
      Lbeta = (1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      g2qq = CF**2*(3./32.-3./4.*zeta2+3./2.*zeta3)
     >       + CF*CA*(-3./4.*zeta3 + 11./12.*zeta2+17./96.)
     >       +nf*CF*(-zeta2/6.-1./48.)

      ofq13=(CF*Kodaira*lntm)/2. + (CF*Kodaira*lnum)/2. 
     +  - 4.*CF**2*zeta2 + 2.*CA*CF*Lbeta*zeta2 - 4.*CF**2*Lbeta*zeta2  
     +  - 2.*CA*CF*lnsm*zeta2 +4.*CF**2*lnsm*zeta2 - 4.*CA*CF*lntm*zeta2
     +  - 20.*CF**2*lntm*zeta2 +8.*CA*CF*lnum*zeta2+12.*CF**2*lnum*zeta2
     +  - 8.*CF**2*zeta3
     +  - 2.*g2qq 

      
      Return
      End


*----------------------------------
      double precision function ofq14(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      
      ofq14 = CF*(lntm + lnum -3./2.)

      Return
      End


*----------------------------------
      double precision function ofq15(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1,beta,Lbeta
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira
      real*8 Gqq11, Gqq22
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))


!Order alphas^1
      Gqq11 = -CF*(Lbeta+1d0)
      Gqq22 =  CF*(4d0*(lnum-lntm) - Lbeta - 1d0)
     ~  +CA/2.*(-3d0*(lnum-lntm) +(lnum+lntm-lnsm) + Lbeta)


      ofq15 = 2d0*CF*(lnsm - lntm - lnum) 

      Return
      End

*----------------------------------
      double precision function ofq16(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1,beta,Lbeta
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira
      real*8 Gqq11, Gqq22, approx
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))


      ofq16 = - CF*(lnsm*lntm -lntm**2 +lnsm*lnum -lnum**2) 

      Return
      End

*----------------------------------
      double precision function ofq17(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1,beta,Lbeta
      real*8 lntm,lnum,lnsm,b2,b3
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira
      real*8 Gqq11, Gqq22, approx
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      b3 = (34d0*CA**2-2d0*nf*(3d0*CF+5d0*CA))/48d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))


      ofq17 = -6.*b2**2*lnsm -3.*b2*CF*(lntm+lnum-3./2.) + b3/128. 

      Return
      End

*----------------------------------
      double precision function ofg10(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,beta,Lbeta
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,BQED

      parameter( pi = 3.14159265359d0 )
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     


      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      BQED = BQED*m2/s**2*pi/2./(CA**2-1d0)**2


      ofg10 = BQED * (  
     +  - t1**2/s**2*CA*CO*lntm          
     +  + t1**2/s**2*CA*CO*lnum         
     +  + u1**2/s**2*CA*CO*lntm         
     +  - u1**2/s**2*CA*CO*lnum         
     +  + CA*CK*(1-2*t1*u1/s**2)*Lbeta  
     +  + CA*CK*(1-2*t1*u1/s**2)        
     +  + 2*CA*CK                       
     +  + CA*CO*(1-2*t1*u1/s**2)*lnsm     
     +  - CA*CO*(1-2*t1*u1/s**2)*lntm     
     +  - CA*CO*(1-2*t1*u1/s**2)*lnum    
     +  - CA*CO*(1-2*t1*u1/s**2)         
     +  - CQED*Lbeta                    
     +  - CQED                                 
     +               )

      Return
      End
*----------------------------------
      double precision function ofg11(s,t1,u1)
      IMPLICIT none
      integer  sclset         
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 mq,muR,kR,muF                      
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2
      common/sclchoice/mq, muR, kR, muF, sclset 


      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)

      ofg11 = ( CA*lntm + CA*lnum ) 

      Return
      End
*----------------------------------
      double precision function ofg20(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,beta,Lbeta
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,BQED,b2
      real*8 dump1, dump2
      parameter( pi = 3.14159265359d0 )
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     


      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      BQED = BQED*m2/s**2*pi/2./(CA**2-1d0)**2

      ofg20 = BQED * (  
     +  - 6*t1**2/s**2*CA**2*CO*lntm        
     +  + 6*t1**2/s**2*CA**2*CO*lnum        
     +  + 6*u1**2/s**2*CA**2*CO*lntm        
     +  - 6*u1**2/s**2*CA**2*CO*lnum        
     +  + 4*b2*CA*CK                        
     +  - 4*b2*CA*CO*(1-2*t1*u1/s**2)      
     +  - 6*CA*CQED*Lbeta                   
     +  - 6*CA*CQED                         
     +  + 6*CA**2*CK*(1-2*t1*u1/s**2)*Lbeta 
     +  + 6*CA**2*CK*(1-2*t1*u1/s**2)       
     +  + 12*CA**2*CK                       
     +  + 6*CA**2*CO*(1-2*t1*u1/s**2)*lnsm  
     +  - 6*CA**2*CO*(1-2*t1*u1/s**2)*lntm  
     +  - 6*CA**2*CO*(1-2*t1*u1/s**2)*lnum  
     +  - 6*CA**2*CO*(1-2*t1*u1/s**2)       
     +                              )

      Return
      End
*----------------------------------
      double precision function ofg21(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,beta,Lbeta
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,BQED,b2
      parameter( pi = 3.14159265359d0 )
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      Lbeta=(1d0-2*m2/s)/beta*dlog((1d0-beta)/(1d0+beta))
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)     

      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      BQED = BQED*m2/s**2*pi/2./(CA**2-1d0)**2


      ofg21 = BQED*(CO*(1-2*t1*u1/s**2) - CK) 
     +  * ( -8d0*b2*CA                        
     +     - 4*CA**2*lnsm + 8*CA**2*lntm
     +     + 8*CA**2*lnum + 4*CA**2 )


      ofg21 = ofg21 + BQED * ( 
     +    4*t1**2/s**2*CA**2*CO*lntm         
     +  - 4*t1**2/s**2*CA**2*CO*lnum         
     +  - 4*u1**2/s**2*CA**2*CO*lntm         
     +  + 4*u1**2/s**2*CA**2*CO*lnum         
     +  + 4*CA*CQED*Lbeta                    
     +  + 4*CA*CQED                          
     +  - 4*CA**2*CK*(1-2*t1*u1/s**2)*Lbeta  
     +  - 4*CA**2*CK*(1-2*t1*u1/s**2)        
     +  - 4*CA**2*CK*lnsm                    
     +  + 4*CA**2*CK*lntm                    
     +  + 4*CA**2*CK*lnum                    
     +  - 4*CA**2*CK                         
     +                         )


      Return
      End
*----------------------------------
      double precision function ofg22(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)


      ofg22 = 5d0*b2*CA - 2*CA**2*lntm - 2*CA**2*lnum

      Return
      End


*----------------------------------
      double precision function ofg13(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)

      ofg13 = CA*(lntm + lnum) - b2/8d0

      Return
      End

*----------------------------------
      double precision function ofg14(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira,g2gg
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      g2gg = CA**2*(2./3.+3./4.*zeta3)-nf*(CF/8.+CA/6.)

      ofg14=-8d0*zeta3*CA**2+CA*Kodaira/2d0*(lntm + lnum)
     >  - 2.*g2gg 
     >  + 2.*b2*CA*(lntm + lnum)*lnsm 
       
      Return
      End

*----------------------------------
      double precision function ofg15(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira,x
      real*8 beta,Lbeta,prefactor,BQED,sigmaBorn
      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)

      prefactor = m2/s**2/(CA**2-1d0)**2/pi**3/16d0
      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      sigmaBorn = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
     +     *BQED*(CO*(1-2*t1*u1/s**2)-CK)

      ofg15=prefactor*BQED*(2d0*CA*zeta2
     +     *(CA*(CA**2-1d0)*(t1**2+u1**2)/s**2 
     +     * ((-CF + CA/2d0)*Lbeta + CA/2d0*(lnsm-lntm-lnum ) - CF)
     +     + (CA**2-1d0)/CA*(CF-CA)*Lbeta + CF*(CA**2-1d0)/CA
     +     + CA**2/2.*(CA**2-1d0)*(lnum-lntm)*(t1**2-u1**2)/s**2
     +     ))

      Return
      End

*----------------------------------
      double precision function ofg16(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira,x
      real*8 beta,Lbeta,prefactor,BQED,sigmaBorn

      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)

      prefactor = m2/s**2/(CA**2-1d0)**2/pi**3/16d0
      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      sigmaBorn = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
     +     *BQED*(CO*(1-2*t1*u1/s**2)-CK)


      ofg16 = 2d0*CA*(lnsm - lntm - lnum)

      Return
      End


*----------------------------------

      double precision function ofg18(s,t1,u1)
      IMPLICIT none
      real*8 s,m2,t1,u1
      real*8 lntm,lnum,lnsm,b2,b3
      real*8 ca, cf, co, ck, cqed, tf, nf
      real*8 pi,zeta2,zeta3,Kodaira,x
      real*8 beta,Lbeta,prefactor,BQED,sigmaBorn
      real*8 remndelta,dump1,dump2

      parameter(pi = 3.14159265359d0)
      parameter (zeta2 = 1.64493d0)
      parameter (zeta3 = 1.20206d0)
      common/group/ca, cf, co, ck, cqed, tf, nf
      common/m2only/m2

      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0
      b3 = (34d0*CA**2-2d0*nf*(3d0*CF+5d0*CA))/48d0
      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)

      ofg18 = -3.*b2*CA*(lntm+lnum)*lnsm +b3/128.

      Return
      End






cxxxxxxxx xxxxxxxxx xxxxxxxxx xxxxxxxxx xxxxxxxxx xxxxxxxxx xxxxxxxxx
       double precision function dilog(x)
       implicit double precision  (a-z)
       dimension b(8)
       integer ncall
       data ncall/0/,pi6/1.644934066848226d+00/,een,vier/1.d+00,.25d+00/
       ncall = 0
       if(ncall.eq.0)go to 2
1      if(x.lt.0)go to 3
       if(x.gt.0.5)go to 4
       z=-dlog(1.-x)
7      z2=z*z
       dilog=z*(z2*(z2*(z2*(z2*(z2*(z2*(z2*b(8)+b(7))+b(6))
     1 +b(5))+b(4))+b(3))+b(2))+een)-z2*vier
       if(x.gt.een)dilog=-dilog-.5*u*u+2.*pi6
       return
2      b(1)=een
       b(2)=een/36.
       b(3)=-een/3600.
       b(4)=een/211680.
       b(5)=-een/(30.*362880.d+00)
       b(6)=5./(66.*39916800.d+00)
       b(7)=-691./(2730.*39916800.d+00*156.)
       b(8)=een/(39916800.d+00*28080.)
       ncall=1
       go to 1
3      if(x.gt.-een)go to 5
       y=een/(een-x)
       z=-dlog(een-y)
       z2=z*z
       u=dlog(y)
       dilog=z*(z2*(z2*(z2*(z2*(z2*(z2*(z2*b(8)+b(7))+b(6))
     1 +b(5))+b(4))+b(3))+b(2))+een)-z2*vier-u*(z+.5*u)-pi6
       return
4      if(x.ge.een)go to 10
       y=een-x
       z=-dlog(x)
6      u=dlog(y)
       z2=z*z
       dilog=-z*(z2*(z2*(z2*(z2*(z2*(z2*(z2*b(8)+b(7))+b(6))
     1 +b(5))+b(4))+b(3))+b(2))+een-u)+z2*vier+pi6
       if(x.gt.een)dilog=-dilog-.5*z*z+pi6*2.
       return
5      y=een/(een-x)
       z=-dlog(y)
       z2=z*z
       dilog=-z*(z2*(z2*(z2*(z2*(z2*(z2*(z2*b(8)+b(7))+b(6))
     1 +b(5))+b(4))+b(3))+b(2))+een)-z2*vier
       return
10     if(x.eq.een)go to 20
       xx=1./x
       if(x.gt.2.)go to 11
       z=dlog(x)
       y=1.-xx
       go to 6
11     u=dlog(x)
       z=-dlog(1.-xx)
       go to 7
20     dilog=pi6
       return
       end
